This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 698295 - Wrong menu rendering
Wrong menu rendering
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: java-1.7.0-openjdk (Show other bugs)
18
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Omair Majid
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-04-20 11:24 EDT by Donato Capitella
Modified: 2014-02-06 10:04 EST (History)
19 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 17:40:40 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Screenshot showing pointer and menu issue (221.24 KB, image/png)
2011-04-20 13:48 EDT, Alan McGinlay
no flags Details

  None (edit)
Description Donato Capitella 2011-04-20 11:24:07 EDT
Description of problem:
Very often the right-click menus are not displayed correctly in Netbeans when using Gnome-shell (I can reproduce similar issues in F14 when using gnome-shell and netbeans). 

Usually you only see a grey box instead of the menu. Other times you see the menu but when you move the cursor the focus doesn't follow the movement correctly. This may also apply to other java GUI applications.
Comment 1 Alan McGinlay 2011-04-20 13:45:49 EDT
I confirm this, I think the title is slightly wrong though as for me the bug is only that the coordinates of the mouse click are several centimetres to the left of the pointer.

I seem to remember the same bug occurring with swing applications 10 years ago :(
Comment 2 Alan McGinlay 2011-04-20 13:48:20 EDT
Created attachment 493562 [details]
Screenshot showing pointer and menu issue
Comment 3 Alan McGinlay 2011-04-20 14:21:01 EDT
OK, fixed the issue by installing oracle jdk so it is a bug in the openjdk. Unfortunately I don't know how to re-assign it.

/gb
Comment 4 Alan McGinlay 2011-04-20 14:23:28 EDT
OK, fixed the issue by installing oracle jdk so it is a bug in the openjdk. Unfortunately I don't know how to re-assign it.

/gb
Comment 5 Denis Lila 2011-05-03 11:01:53 EDT
I'm definitely seeing something wrong when using netbeans on gnome3 too.

It's similar to Alan's problem, except everything is ok when netbeans is not maximized. When I click on one of the menus, it won't stay open unless I hold down the left button (which is a problem in itself), and when I just drag it down (hoping that I can choose the option I want by just releasing the left button), the menu I am on closes and one about 50 pixels to the left opens up.

Another problem is that if I click on the code window, the mouse pointer changes to the "|" (which is fine), but when I mouse over to the scrollbar it doesn't change back to the arrow.

I can confirm that none of this is a problem on the proprietary openjdk6 (u25). I am trying to test on openjdk7.

I will look into this.
Comment 6 Denis Lila 2011-05-04 12:16:03 EDT
@Alan
@Donato

Hi.

After updating my Fedora 15 system the issues I was having with netbeans disappeared.

Could you please try updating and running netbeans again?

Thank you,
Denis.
Comment 7 Denis Lila 2011-05-10 10:31:58 EDT
Proposed fix (for at least the click position problem):
http://icedtea.classpath.org/~dlila/webrevs/mutterBug/
Comment 8 Alan McGinlay 2011-05-22 15:22:37 EDT
I am still seeing this with oracle jdk :/. It only happens when the window is full screen. If I move the window manually to take up nearly the whole screen then it works fine. 

bug in gnome-shell?

/A
Comment 9 Denis Lila 2011-05-24 10:24:34 EDT
(In reply to comment #8)

Hi Alan.

> I am still seeing this with oracle jdk :/.

Well, I don't work for Oracle ;-)
But yes, I'm aware that the problem is still there in Oracle's jdk. However, it should be fixed in icedtea6-1.10, which you can clone and build from here:
http://icedtea.classpath.org/hg/release/icedtea6-1.10/

> It only happens when the window is full screen. If I move the window manually
> to take up nearly the whole screen then it works fine. 

Try moving the small window to the top left of the screen, then maximize. That
should also work.

The problem is that when the window is maximized java was not updating the window position properly. If the window was at pixel (100,100) then it was maximized, AWT thinks that it is still at pixel (100,100) instead of close to (0,0). This causes it to miscalculate mouse pointer positions relative to the window.

> bug in gnome-shell?
> 
> /A
Comment 10 Ricardo Veguilla 2011-06-18 15:13:59 EDT
Still seeing this with various java swing apps (IntelliJ IDEA, soapUI) with both java-1.6.0-openjdk-1.6.0.0-58.1.10.2.fc15.x86_64 and oracle's jdk-6u26-linux-x64.bin.
Comment 11 Denis Lila 2011-06-20 11:13:57 EDT
Hi Ricardo.

> Still seeing this with various java swing apps (IntelliJ IDEA, soapUI) with
> both java-1.6.0-openjdk-1.6.0.0-58.1.10.2.fc15.x86_64 and oracle's
> jdk-6u26-linux-x64.bin.

Can you plese give more details? When you say "still seeing this" are you referring to the clicking problem or the problem with menu rendering described in the first comment?
Are you seeing the problem on netbeans? On IntelliJ IDEA, what steps do you follow to reproduce the problem?

I tested IDEA on Fedora 15 with icedtea6-1.10.2 and it looks and behaves exactly the same as it does on Fedora 13 with the same icedtea6 version.
Comment 12 Ricardo Veguilla 2011-06-20 12:13:13 EDT
Denis,

Sorry I was not clear, I'm not seeing the grey menu rendering issue. I see the incorrect mouse pointer position on java menus when running the application maximized under gnome-shell. 


1. If I single-click a menu in the menu bar, the menu will flash
briefly and disappears (instead of staying opened).
2. If I click and hold on a menu in the menu bar, the menu stays
opened, but the selection is vertically displaced (I have to move the
mouse to the third menu item to select the first one, for example).
3. If I right-click to access a context-menu, the selection is
displaced as described in the previous case).

I haven't tried to reproduce the bug on Netbeans yet.
Comment 13 Denis Lila 2011-06-20 14:37:30 EDT
Hi Ricardo.

That sounds exactly like the problem we were seeing with netbeans. I pushed this changeset as a fix for it:
http://icedtea.classpath.org/hg/release/icedtea6-1.10/rev/711c59eac969

This is very strange, because IDEA and netbeans are behaving perfectly fine on my Fedora 15 installation, and I'm sure I'm using icedtea6-1.10.2.

I have a few more questions, if you don't mind:
Are you seeing the problem *only* after IDEA is maximized? Are you certain you're using 1.10.2 when running it? What command do you use to start it up? Are the variables IDEA_JDK or IDEA_HOME set to anything? I'm thinking that IDEA might always be using oracle's jdk (and I _can_ reproduce the problem with u26).

Running "ps aux | grep java" while IDEA is also running should tell us what jdk it's using.
Comment 14 Ricardo Veguilla 2011-06-21 01:46:48 EDT
Denis, 

You were right, I had the IDEA_JDK variable set to an oracle jdk at some point after I first noticed the problem using a previous openjdk release, and forgot to remove it.  

I just tried running IDEA again using openjdk-1.6.0.0-58.1.10.2 (and with the variable unset) and the problem no longer occurs. 

Sorry for the confusion.
Comment 15 Denis Lila 2011-06-21 08:59:36 EDT
(In reply to comment #14)
> Denis, 
> 
> You were right, I had the IDEA_JDK variable set to an oracle jdk at some point
> after I first noticed the problem using a previous openjdk release, and forgot
> to remove it.  
> 
> I just tried running IDEA again using openjdk-1.6.0.0-58.1.10.2 (and with the
> variable unset) and the problem no longer occurs. 

That's great. In that case I'm closing this bug as fixed.

> Sorry for the confusion.

No problem.
Comment 16 Michal Ambroz 2011-06-21 12:50:10 EDT
I have checked now:
- issue fixed for openjdk
- issue still persists for Oracle/Sun java 1.6.0 update 26

I have reported the issue to Sun Oracle on bugs.sun.com.

Workaround Java Swing applications running with Oracle/Sun JDK on Fedora 15 with Gnome 3 is to move the application to upper left corner and then maximize. The mouse offset will be then 0,0 and the application menu will be working fine.

I have tested with ZAP proxy.

Best regards
Michal Ambroz
Comment 17 Denis Lila 2011-06-21 13:01:39 EDT
Michal

> I have checked now:
> - issue fixed for openjdk

That's not quite correct. It is fixed for icedtea6-1.10 and icedtea7, but the openjdk repositories in http://hg.openjdk.java.net still have the problem.
Comment 18 blue_t_fox 2011-07-06 20:43:16 EDT
The problem also still exists for Oracle's official JDK (currently at 1.6.0_26 on my system).
Comment 19 Andrew John Hughes 2011-07-07 08:01:58 EDT
We can't do anything about what fixes Oracle do or do not include in their proprietary JDK.
Comment 20 Tadeusz Piotr Pawlus 2011-07-09 16:06:57 EDT
I found possible workaround:

1. edit netbeans.conf file.
2. to line netbeans_default_options add -J-Dnetbeans.popup.linuxhack=true
3. restart your netbeans & observe correct menu/popup behaviour

My system:
Fedora 15 with gnome-shell enabled
Oracle Java6 jdk6u26.
Comment 21 Ahmed AbuBakr Mohamed Eltawela 2011-10-23 05:26:35 EDT
(In reply to comment #1)
> I confirm this, I think the title is slightly wrong though as for me the bug is
> only that the coordinates of the mouse click are several centimetres to the
> left of the pointer.
> 
> I seem to remember the same bug occurring with swing applications 10 years ago
> :(

I confirm this too with sun jdk 1.7 and gnome-shell
Comment 22 Ahmed AbuBakr Mohamed Eltawela 2011-10-23 05:30:18 EDT
(In reply to comment #1)
> I confirm this, I think the title is slightly wrong though as for me the bug is
> only that the coordinates of the mouse click are several centimetres to the
> left of the pointer.
> 
> I seem to remember the same bug occurring with swing applications 10 years ago
> :(

I confirm this (In reply to comment #9)
> (In reply to comment #8)
> 
> Hi Alan.
> 
> > I am still seeing this with oracle jdk :/.
> 
> Well, I don't work for Oracle ;-)
> But yes, I'm aware that the problem is still there in Oracle's jdk. However, it
> should be fixed in icedtea6-1.10, which you can clone and build from here:
> http://icedtea.classpath.org/hg/release/icedtea6-1.10/
> 
> > It only happens when the window is full screen. If I move the window manually
> > to take up nearly the whole screen then it works fine. 
> 
> Try moving the small window to the top left of the screen, then maximize. That
> should also work.
> 
> The problem is that when the window is maximized java was not updating the
> window position properly. If the window was at pixel (100,100) then it was
> maximized, AWT thinks that it is still at pixel (100,100) instead of close to
> (0,0). This causes it to miscalculate mouse pointer positions relative to the
> window.
> 
> > bug in gnome-shell?
> > 
> > /A

I confirm that this bug appears when the window is maximized as you mentioned.
Comment 23 Andrejs 2011-12-05 10:01:58 EST
Solution for this problem.

Apparently problem is related to Oracle java jdk, so to fix this you must install openjdk.

yum install java-1.7.0-openjdk
yum install java-1.7.0-openjdk-devel

Then in your netbeans etc/netbeans.conf show full path to openjdk like so:
netbeans_jdkhome="/usr/lib/jvm/java-1.7.0-openjdk-1.7.0.1"

After that run netbeans and under Help->About you can check netbeans java version.
Comment 24 Nathanael Noblet 2013-04-22 13:37:59 EDT
I'm experiencing this issue now on F18. Its exactly the same as described here. If I un-maximize the menus work. 

I've followed the same workaround in comment 23 without success.

I have both Oracle and openjdk installed but regardless of the settings via alternatives or editing netbeans.conf etc...
Comment 25 Nathanael Noblet 2013-04-22 13:40:51 EDT
One more bit of info. If I 'maximize' the window manually using the mouse to enlarge the window the menus work...
Comment 26 Omair Majid 2013-04-22 13:44:07 EDT
Bug 918055 contains more detailed information about this.
Comment 27 Robertus 2013-05-06 02:43:49 EDT
Hi all,

I experienced with this issue too. Previously I tried below workaround:
1. Maximize manually by using mouse to enlarge the window,
2. Move the window to the top left, and click Maximize button of the window.

But once I installed Compiz Fusion, now the problem has gone. Now I can maximize the windows of Java Swing apps (i.e. Netbeans, SQLDeveloper) by using maximize button without any issues on the menu. I think this issue hasn't been solved yet.

FYI, I'm using Oracle JDK 1.6.0_45 on Linux Mint 14 MATE.

Hope this help. Thanks
Comment 28 Fedora End Of Life 2013-12-21 09:54:57 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 29 Fedora End Of Life 2014-02-05 17:40:40 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.